



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>YOLO(Darknet官方)训练分类器</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">YOLO(Darknet官方)训练分类器</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 23:25:44 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><div>
<div>目录</div>
<ul><li><a href="#1-分类数据准备" rel="external nofollow noreferrer">1. 分类数据准备</a></li>
<li><a href="#2-darknet配置" rel="external nofollow noreferrer">2. Darknet配置</a></li>
<li><a href="#3-darknet命令使用" rel="external nofollow noreferrer">3. Darknet命令使用</a></li>
<li><a href="#4-cifar-10-使用示例" rel="external nofollow noreferrer">4. cifar-10 使用示例</a></li></ul>
</div>
<h2>1. 分类数据准备</h2>
<p>需要的文件列表：</p>
<pre class="prettyprint linenums"><code>1. train.list : 训练的图片的绝对路径<br />
2. test.list : 用于测试的图片的绝对路径<br />
3. labels.txt : 所有的类别，一行一个类<br />
4. voc.data : darknet配置文件，记录相关位置信息<br />
5. cifar.cfg : 网络配置文件<br />
</code></pre>
<p>按照以下目录结构进行构造：</p>
<pre class="prettyprint linenums"><code>VOCdevkit<br />
	VOC2017<br />
		JPEGImages<br />
			train<br />
			test<br />
</code></pre>
<p>其中训练和测试的比例设置：</p>
<ol><li>如果数据集比较小（10,000左右），那么设置的比例为：训练:测试 = 80% : 20%</li>
<li>如果数据集比较大（100,000左右），那么设置的比例为：训练:测试 = 99% :1%</li></ol>
<p>然后转到JPEGImages目录下进行以下操作：</p>
<pre class="prettyprint linenums"><code>find `pwd`/train -name \*.jpg &gt; train.list<br />
find `pwd`/test -name \*.jpg &gt; test.list<br />
</code></pre>
<p>构造labels.txt文件内容</p>
<pre class="prettyprint linenums"><code>airplane<br />
automobile<br />
bird<br />
cat<br />
deer<br />
dog<br />
frog<br />
horse<br />
ship<br />
truck<br />
</code></pre>
<p>构造voc.data文件中内容：</p>
<pre class="prettyprint linenums"><code>classes=10 #设置的类别个数<br />
train  = data/cifar/train.list #上边构造的训练列表<br />
valid  = data/cifar/test.list # 上边构造的测试列表<br />
labels = data/cifar/labels.txt # 记录类别<br />
backup = backup/ #训练的网络文件的位置<br />
top=2 # 计算top-n的准确率<br />
</code></pre>
<p>网络配置文件的选择：</p>
<p><a href="https://pjreddie.com/darknet/imagenet/" rel="external nofollow noreferrer">网络配置文件以及预训练模型</a></p>
<p>以AlexNet为例：</p>
<pre class="prettyprint linenums"><code>[net]<br />
# Training<br />
# batch=128<br />
# subdivisions=1<br />
# Testing<br />
batch=1<br />
subdivisions=1<br />
height=227<br />
width=227<br />
channels=3<br />
momentum=0.9<br />
decay=0.0005<br />
max_crop=256

learning_rate=0.01<br />
policy=poly<br />
power=4<br />
max_batches=800000

angle=7<br />
hue = .1<br />
saturation=.75<br />
exposure=.75<br />
aspect=.75

[convolutional]<br />
filters=96<br />
size=11<br />
stride=4<br />
pad=0<br />
activation=relu

[maxpool]<br />
size=3<br />
stride=2<br />
padding=0

[convolutional]<br />
filters=256<br />
size=5<br />
stride=1<br />
pad=1<br />
activation=relu

[maxpool]<br />
size=3<br />
stride=2<br />
padding=0

[convolutional]<br />
filters=384<br />
size=3<br />
stride=1<br />
pad=1<br />
activation=relu

[convolutional]<br />
filters=384<br />
size=3<br />
stride=1<br />
pad=1<br />
activation=relu

[convolutional]<br />
filters=256<br />
size=3<br />
stride=1<br />
pad=1<br />
activation=relu

[maxpool]<br />
size=3<br />
stride=2<br />
padding=0

[connected]<br />
output=4096<br />
activation=relu

[dropout]<br />
probability=.5

[connected]<br />
output=4096<br />
activation=relu

[dropout]<br />
probability=.5

[connected]<br />
output=1000<br />
activation=linear

[softmax]<br />
groups=1<br />
</code></pre>
<h2>2. Darknet配置</h2>
<ol><li>下载darknet</li></ol>
<pre class="prettyprint linenums"><code>git clone https://github.com/pjreddie/darknet.git<br />
cd darknet<br />
make -j4<br />
</code></pre>
<p>如果有GPU并且安装了cuda8.0和cudnn6.0，请在Makefile中进行修改，将对应的CUDA=0改为CUDA=1.</p>
<ol><li>将在第一步构造的文件放到对应位置</li></ol>
<pre class="prettyprint linenums"><code>darknet<br />
	cfg -- AlexNet.cfg<br />
	data -- voc.data, labels.txt, train.list, test.list<br />
</code></pre>
<p>其中voc.data中的内容直接指到对应的文件上。</p>
<h2>3. Darknet命令使用</h2>
<ol><li><p>train命令</p>
<p><code>./darknet classifier train data/voc.data cfg/AlexNet.cfg  </code></p></li>
<li><p>valid命令</p>
<p><code>./darknet classifier valid data/voc.data cfg/AlexNet.cfg backup AlexNet.backup</code></p></li>
<li><p>predict命令</p>
<p><code>./darknet classifier predict data/voc.data cfg/AlexNet.cfg backup AlexNet.backup ./cat.png</code></p></li>
<li><p>终端训练后重新训练</p>
<p><code>./darknet classifier train data/voc.data cfg/AlexNet.cfg backup/AlexNet.backup  </code></p></li>
<li><p>设置训练使用的GPU</p>
<p><code>-gpus 0,1</code></p></li></ol>
<h2>4. cifar-10 使用示例</h2>
<ol><li><p>数据获取</p>
<pre class="prettyprint linenums"><code>cd data<br />
wget https://pjreddie.com/media/files/cifar.tgz<br />
tar xzf cifar.tgz

cd cifar<br />
find `pwd`/train -name \*.png &gt; train.list<br />
find `pwd`/test -name \*.png &gt; test.list<br />
cd ../..<br />
</code></pre></li>
<li><p>选择config文件</p>
<pre class="prettyprint linenums"><code>classes=10<br />
train  = data/cifar/train.list<br />
valid  = data/cifar/test.list<br />
labels = data/cifar/labels.txt<br />
backup = backup/<br />
top=2<br />
</code></pre></li>
<li><p>创建网络配置文件</p>
<p>cifar_small.cfg(官方提供)</p>
<pre class="prettyprint linenums"><code>[net]<br />
batch=128<br />
subdivisions=1<br />
height=28<br />
width=28<br />
channels=3<br />
max_crop=32<br />
min_crop=32

hue=.1<br />
saturation=.75<br />
exposure=.75

learning_rate=0.1<br />
policy=poly<br />
power=4<br />
max_batches = 5000<br />
momentum=0.9<br />
decay=0.0005

[convolutional]<br />
batch_normalize=1<br />
filters=32<br />
size=3<br />
stride=1<br />
pad=1<br />
activation=leaky

[maxpool]<br />
size=2<br />
stride=2

[convolutional]<br />
batch_normalize=1<br />
filters=16<br />
size=1<br />
stride=1<br />
pad=1<br />
activation=leaky

[convolutional]<br />
batch_normalize=1<br />
filters=64<br />
size=3<br />
stride=1<br />
pad=1<br />
activation=leaky

[maxpool]<br />
size=2<br />
stride=2

[convolutional]<br />
batch_normalize=1<br />
filters=32<br />
size=1<br />
stride=1<br />
pad=1<br />
activation=leaky

[convolutional]<br />
batch_normalize=1<br />
filters=128<br />
size=3<br />
stride=1<br />
pad=1<br />
activation=leaky

[convolutional]<br />
batch_normalize=1<br />
filters=64<br />
size=1<br />
stride=1<br />
pad=1<br />
activation=leaky

[convolutional]<br />
filters=10<br />
size=1<br />
stride=1<br />
pad=1<br />
activation=leaky

[avgpool]

[softmax]<br />
</code></pre></li>
<li><p>训练</p>
<p>训练：<code>./darknet classifier train cfg/cifar.data cfg/cifar_small.cfg</code></p>
<p>valid: <code>./darknet classifier valid cfg/cifar.data cfg/cifar_small.cfg backup/cifar_small.backup</code></p></li></ol>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/495xzr08.html">新建structs2 web应用及structs&period;xml常用基础配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zrzv1q.html">postman插件安装教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8eo7rkq.html">虚拟化 模板制作 rhev笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/3901w7o8.html">ASP&period;NET XmlSerializer权限问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mxoy69.html">HTML5&plus;JS 《五子飞》游戏实现（六）鼠标响应与多重选择</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1jxex9.html">c&num;中进程的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdwypr8.html">&lbrack;1&period;1&rsqb;Knowledge that should be prepared</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1gkd79.html">D - Silver Cow Party</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpmrdj9.html">shell中 if else以及大于、小于、等于逻辑表达式介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y6w2w8.html">eclipse中将项目打包成jar的两种方法，及其问题与解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1m1j49.html">pycharm最新code码，分享给大家</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1m5xg9.html">Git Submodule管理项目子模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jmrjnq.html">mysql数据库卸载和安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1ljo49.html">Mac 安装win10操作系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j15nel9.html">go学习day2</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7opd1g8.html">VS2012 编译报错：找不到编译动态表达式所需的一个或多个类型。是否缺少引用&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9533znv8.html">LDAP none、simple、strong 笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql11p109.html">微信小程序&mdash;&mdash;引用阿里云字体</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4vpkxq.html">neuroph Perceptron Sample</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pk1dw8.html">C&num;程序集系列11&comma;全局程序集缓存</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9637ok39.html">df值自由度学习&lbrack;转载&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9637ory9.html">阿里云安装docker 指定版本</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vpk34q.html">2018-2019-2 网络对抗技术 20165324   Exp3：免杀原理与实践</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4pmzr0q.html">pythonon ddt数据驱动二（json&comma; yaml 驱动）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7el7nj9.html">X-UA-Compatible</a>
			</li>
						<li><a href="https://www.batexi.com/a/953mpde8.html">mac远程连接windows</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyv445gq.html">thymeleaf 配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjll628.html">python &comma; 顺序迭代合并后的list对象</a>
			</li>
						<li><a href="https://www.batexi.com/a/93pdnvn8.html">python 采坑总结 调用键盘事件后导致键盘失灵的可能原因</a>
			</li>
						<li><a href="https://www.batexi.com/a/93pdn2z8.html">Linux基础命令---bzcat</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
